Index: trunk/LMDZ.GENERIC/libf/phystd/physiq.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/physiq.F90	(revision 1304)
+++ trunk/LMDZ.GENERIC/libf/phystd/physiq.F90	(revision 1308)
@@ -12,5 +12,5 @@
       use gases_h, only: gnom, gfrac
       use radcommon_h, only: sigma, eclipse, glat, grav
-      use radii_mod, only: h2o_reffrad, co2_reffrad, h2o_cloudrad
+      use radii_mod, only: h2o_reffrad, co2_reffrad
       use aerosol_mod, only: iaero_co2, iaero_h2o
       use surfdat_h, only: phisfi, albedodat, zmea, zstd, zsig, zgam, zthe, &
@@ -32,5 +32,6 @@
       use planetwide_mod, only: planetwide_minval,planetwide_maxval,planetwide_sumval
       use mod_phys_lmdz_para, only : is_master
-
+      use planete_mod, only: apoastr, periastr, year_day, peri_day, &
+                            obliquit, nres, z0
 
       implicit none
@@ -102,8 +103,8 @@
 !   ------
 !
-!    pdu(ngrid,nlayermx)        \
-!    pdv(ngrid,nlayermx)         \  Temporal derivative of the corresponding
-!    pdt(ngrid,nlayermx)         /  variables due to physical processes.
-!    pdq(ngrid,nlayermx)        /
+!    pdu(ngrid,nlayer)        \
+!    pdv(ngrid,nlayer)         \  Temporal derivative of the corresponding
+!    pdt(ngrid,nlayer)         /  variables due to physical processes.
+!    pdq(ngrid,nlayer)        /
 !    pdpsrf(ngrid)             /
 !    tracerdyn                 call tracer in dynamical part of GCM ?
@@ -131,9 +132,9 @@
 !    ------------------
 
-#include "dimensions.h"
-#include "dimphys.h"
+!#include "dimensions.h"
+!#include "dimphys.h"
 #include "callkeys.h"
 #include "comcstfi.h"
-#include "planete.h"
+!#include "planete.h"
 !#include "control.h"
 #include "netcdf.inc"
@@ -179,5 +180,5 @@
 !     "longrefvis" set in dimradmars.h , for one of the "naerkind"  kind of
 !      aerosol optical properties:
-!      real aerosol(ngrid,nlayermx,naerkind) 
+!      real aerosol(ngrid,nlayer,naerkind) 
 !     this is now internal to callcorrk and hence no longer needed here
 
@@ -207,6 +208,6 @@
 !     aerosol (dust or ice) extinction optical depth  at reference wavelength 
 !     for the "naerkind" optically active aerosols:
-      real aerosol(ngrid,nlayermx,naerkind) 
-      real zh(ngrid,nlayermx)      ! potential temperature (K)
+      real aerosol(ngrid,nlayer,naerkind) 
+      real zh(ngrid,nlayer)      ! potential temperature (K)
 
       character*80 fichier 
@@ -228,56 +229,56 @@
       real zls                       ! solar longitude (rad)
       real zday                      ! date (time since Ls=0, in martian days)
-      real zzlay(ngrid,nlayermx)   ! altitude at the middle of the layers
-      real zzlev(ngrid,nlayermx+1) ! altitude at layer boundaries
+      real zzlay(ngrid,nlayer)   ! altitude at the middle of the layers
+      real zzlev(ngrid,nlayer+1) ! altitude at layer boundaries
       real latvl1,lonvl1             ! Viking Lander 1 point (for diagnostic)
 
 !     Tendencies due to various processes:
       real dqsurf(ngrid,nq)
-      real cldtlw(ngrid,nlayermx)                           ! (K/s) LW heating rate for clear areas
-      real cldtsw(ngrid,nlayermx)                           ! (K/s) SW heating rate for clear areas
+      real cldtlw(ngrid,nlayer)                           ! (K/s) LW heating rate for clear areas
+      real cldtsw(ngrid,nlayer)                           ! (K/s) SW heating rate for clear areas
       real zdtsurf(ngrid)                                   ! (K/s)
-      real dtlscale(ngrid,nlayermx)
-      real zdvdif(ngrid,nlayermx),zdudif(ngrid,nlayermx)  ! (m.s-2)
-      real zdhdif(ngrid,nlayermx), zdtsdif(ngrid)         ! (K/s)
-      real zdtdif(ngrid,nlayermx)			      ! (K/s)
-      real zdvadj(ngrid,nlayermx),zduadj(ngrid,nlayermx)  ! (m.s-2)
-      real zdhadj(ngrid,nlayermx)                           ! (K/s)
-      real zdtgw(ngrid,nlayermx)                            ! (K/s)
-      real zdtmr(ngrid,nlayermx)
-      real zdugw(ngrid,nlayermx),zdvgw(ngrid,nlayermx)    ! (m.s-2)
-      real zdtc(ngrid,nlayermx),zdtsurfc(ngrid)
-      real zdvc(ngrid,nlayermx),zduc(ngrid,nlayermx)
-      real zdumr(ngrid,nlayermx),zdvmr(ngrid,nlayermx)
+      real dtlscale(ngrid,nlayer)
+      real zdvdif(ngrid,nlayer),zdudif(ngrid,nlayer)  ! (m.s-2)
+      real zdhdif(ngrid,nlayer), zdtsdif(ngrid)         ! (K/s)
+      real zdtdif(ngrid,nlayer)			      ! (K/s)
+      real zdvadj(ngrid,nlayer),zduadj(ngrid,nlayer)  ! (m.s-2)
+      real zdhadj(ngrid,nlayer)                           ! (K/s)
+      real zdtgw(ngrid,nlayer)                            ! (K/s)
+      real zdtmr(ngrid,nlayer)
+      real zdugw(ngrid,nlayer),zdvgw(ngrid,nlayer)    ! (m.s-2)
+      real zdtc(ngrid,nlayer),zdtsurfc(ngrid)
+      real zdvc(ngrid,nlayer),zduc(ngrid,nlayer)
+      real zdumr(ngrid,nlayer),zdvmr(ngrid,nlayer)
       real zdtsurfmr(ngrid)
       
-      real zdmassmr(ngrid,nlayermx),zdpsrfmr(ngrid)
+      real zdmassmr(ngrid,nlayer),zdpsrfmr(ngrid)
       real zdmassmr_col(ngrid)
 
-      real zdqdif(ngrid,nlayermx,nq), zdqsdif(ngrid,nq)
-      real zdqevap(ngrid,nlayermx)
-      real zdqsed(ngrid,nlayermx,nq), zdqssed(ngrid,nq)
-      real zdqdev(ngrid,nlayermx,nq), zdqsdev(ngrid,nq)
-      real zdqadj(ngrid,nlayermx,nq)
-      real zdqc(ngrid,nlayermx,nq)
-      real zdqmr(ngrid,nlayermx,nq),zdqsurfmr(ngrid,nq)
-      real zdqlscale(ngrid,nlayermx,nq)
+      real zdqdif(ngrid,nlayer,nq), zdqsdif(ngrid,nq)
+      real zdqevap(ngrid,nlayer)
+      real zdqsed(ngrid,nlayer,nq), zdqssed(ngrid,nq)
+      real zdqdev(ngrid,nlayer,nq), zdqsdev(ngrid,nq)
+      real zdqadj(ngrid,nlayer,nq)
+      real zdqc(ngrid,nlayer,nq)
+      real zdqmr(ngrid,nlayer,nq),zdqsurfmr(ngrid,nq)
+      real zdqlscale(ngrid,nlayer,nq)
       real zdqslscale(ngrid,nq)
-      real zdqchim(ngrid,nlayermx,nq)
+      real zdqchim(ngrid,nlayer,nq)
       real zdqschim(ngrid,nq)
 
-      real zdteuv(ngrid,nlayermx)    ! (K/s)
-      real zdtconduc(ngrid,nlayermx) ! (K/s)
-      real zdumolvis(ngrid,nlayermx)
-      real zdvmolvis(ngrid,nlayermx)
-      real zdqmoldiff(ngrid,nlayermx,nq)
+      real zdteuv(ngrid,nlayer)    ! (K/s)
+      real zdtconduc(ngrid,nlayer) ! (K/s)
+      real zdumolvis(ngrid,nlayer)
+      real zdvmolvis(ngrid,nlayer)
+      real zdqmoldiff(ngrid,nlayer,nq)
 
 !     Local variables for local calculations:
       real zflubid(ngrid)
-      real zplanck(ngrid),zpopsk(ngrid,nlayermx)
-      real zdum1(ngrid,nlayermx)
-      real zdum2(ngrid,nlayermx)
+      real zplanck(ngrid),zpopsk(ngrid,nlayer)
+      real zdum1(ngrid,nlayer)
+      real zdum2(ngrid,nlayer)
       real ztim1,ztim2,ztim3, z1,z2
       real ztime_fin
-      real zdh(ngrid,nlayermx)
+      real zdh(ngrid,nlayer)
       real gmplanet
       real taux(ngrid),tauy(ngrid)
@@ -288,21 +289,21 @@
 ! local variables only used for diagnostics (output in file "diagfi" or "stats")
 ! ------------------------------------------------------------------------------
-      real ps(ngrid), zt(ngrid,nlayermx)
-      real zu(ngrid,nlayermx),zv(ngrid,nlayermx)
-      real zq(ngrid,nlayermx,nq)
+      real ps(ngrid), zt(ngrid,nlayer)
+      real zu(ngrid,nlayer),zv(ngrid,nlayer)
+      real zq(ngrid,nlayer,nq)
       character*2 str2
       character*5 str5
-      real zdtadj(ngrid,nlayermx)
-      real zdtdyn(ngrid,nlayermx)
+      real zdtadj(ngrid,nlayer)
+      real zdtdyn(ngrid,nlayer)
       real,allocatable,dimension(:,:),save :: ztprevious
-      real reff(ngrid,nlayermx) ! effective dust radius (used if doubleq=T)
+      real reff(ngrid,nlayer) ! effective dust radius (used if doubleq=T)
       real qtot1,qtot2            ! total aerosol mass
       integer igmin, lmin
       logical tdiag
 
-      real zplev(ngrid,nlayermx+1),zplay(ngrid,nlayermx)
+      real zplev(ngrid,nlayer+1),zplay(ngrid,nlayer)
       real zstress(ngrid), cd
-      real hco2(nq), tmean, zlocal(nlayermx)
-      real vmr(ngrid,nlayermx) ! volume mixing ratio
+      real hco2(nq), tmean, zlocal(nlayer)
+      real vmr(ngrid,nlayer) ! volume mixing ratio
 
       real time_phys
@@ -318,6 +319,6 @@
 
 !     included by RW for H2O precipitation
-      real zdtrain(ngrid,nlayermx)
-      real zdqrain(ngrid,nlayermx,nq)
+      real zdtrain(ngrid,nlayer)
+      real zdqrain(ngrid,nlayer,nq)
       real zdqsrain(ngrid)
       real zdqssnow(ngrid)
@@ -325,12 +326,12 @@
 
 !     included by RW for H2O Manabe scheme
-      real dtmoist(ngrid,nlayermx)
-      real dqmoist(ngrid,nlayermx,nq)
-
-      real qvap(ngrid,nlayermx)
-      real dqvaplscale(ngrid,nlayermx)
-      real dqcldlscale(ngrid,nlayermx)
-      real rneb_man(ngrid,nlayermx)
-      real rneb_lsc(ngrid,nlayermx)
+      real dtmoist(ngrid,nlayer)
+      real dqmoist(ngrid,nlayer,nq)
+
+      real qvap(ngrid,nlayer)
+      real dqvaplscale(ngrid,nlayer)
+      real dqcldlscale(ngrid,nlayer)
+      real rneb_man(ngrid,nlayer)
+      real rneb_lsc(ngrid,nlayer)
 
 !     included by RW to account for surface cooling by evaporation
@@ -339,10 +340,10 @@
 
 !     to test energy conservation (RW+JL)
-      real mass(ngrid,nlayermx),massarea(ngrid,nlayermx)
+      real mass(ngrid,nlayer),massarea(ngrid,nlayer)
       real dEtot, dEtots, AtmToSurf_TurbFlux
       real,save :: dEtotSW, dEtotsSW, dEtotLW, dEtotsLW
-      real dEzRadsw(ngrid,nlayermx),dEzRadlw(ngrid,nlayermx),dEzdiff(ngrid,nlayermx)
+      real dEzRadsw(ngrid,nlayer),dEzRadlw(ngrid,nlayer),dEzdiff(ngrid,nlayer)
       real dEdiffs(ngrid),dEdiff(ngrid)
-      real madjdE(ngrid), lscaledE(ngrid),madjdEz(ngrid,nlayermx), lscaledEz(ngrid,nlayermx)
+      real madjdE(ngrid), lscaledE(ngrid),madjdEz(ngrid,nlayer), lscaledEz(ngrid,nlayer)
 !JL12 conservation test for mean flow kinetic energy has been disabled temporarily
       real dtmoist_max,dtmoist_min
@@ -351,8 +352,8 @@
 
 !     included by BC for evaporation     
-      real qevap(ngrid,nlayermx,nq)
-      real tevap(ngrid,nlayermx)
-      real dqevap1(ngrid,nlayermx)
-      real dtevap1(ngrid,nlayermx)
+      real qevap(ngrid,nlayer,nq)
+      real tevap(ngrid,nlayer)
+      real dqevap1(ngrid,nlayer)
+      real dtevap1(ngrid,nlayer)
 
 !     included by BC for hydrology
@@ -367,5 +368,5 @@
 
 !     included by RW for RH diagnostic
-      real qsat(ngrid,nlayermx), RH(ngrid,nlayermx), H2Omaxcol(ngrid),psat_tmp
+      real qsat(ngrid,nlayer), RH(ngrid,nlayer), H2Omaxcol(ngrid),psat_tmp
 
 !     included by RW for hydrology
@@ -378,6 +379,6 @@
 !     included by BC for double radiative transfer call
       logical clearsky
-      real zdtsw1(ngrid,nlayermx)
-      real zdtlw1(ngrid,nlayermx)
+      real zdtsw1(ngrid,nlayer)
+      real zdtlw1(ngrid,nlayer)
       real fluxsurf_lw1(ngrid)     
       real fluxsurf_sw1(ngrid)  
@@ -402,20 +403,20 @@
 
 !     included by RW for temp convadj conservation test
-      real playtest(nlayermx)
-      real plevtest(nlayermx)
-      real ttest(nlayermx)
-      real qtest(nlayermx)
+      real playtest(nlayer)
+      real plevtest(nlayer)
+      real ttest(nlayer)
+      real qtest(nlayer)
       integer igtest
 
 !     included by RW for runway greenhouse 1D study
-      real muvar(ngrid,nlayermx+1)
+      real muvar(ngrid,nlayer+1)
 
 !     included by RW for variable H2O particle sizes
       real,allocatable,dimension(:,:,:),save :: reffrad ! aerosol effective radius (m)
       real,allocatable,dimension(:,:,:),save :: nueffrad ! aerosol effective radius variance
-!      real :: nueffrad_dummy(ngrid,nlayermx,naerkind) !! AS. This is temporary. Check below why.
-      real :: reffh2oliq(ngrid,nlayermx) ! liquid water particles effective radius (m)
-      real :: reffh2oice(ngrid,nlayermx) ! water ice particles effective radius (m)
-   !   real reffH2O(ngrid,nlayermx)
+!      real :: nueffrad_dummy(ngrid,nlayer,naerkind) !! AS. This is temporary. Check below why.
+      real :: reffh2oliq(ngrid,nlayer) ! liquid water particles effective radius (m)
+      real :: reffh2oice(ngrid,nlayer) ! water ice particles effective radius (m)
+   !   real reffH2O(ngrid,nlayer)
       real reffcol(ngrid,naerkind)
 
@@ -469,5 +470,5 @@
         ALLOCATE(rnat(ngrid))         
         ALLOCATE(emis(ngrid))   
-        ALLOCATE(dtrad(ngrid,nlayermx))
+        ALLOCATE(dtrad(ngrid,nlayer))
         ALLOCATE(fluxrad_sky(ngrid))
         ALLOCATE(fluxrad(ngrid))    
@@ -475,12 +476,12 @@
         ALLOCATE(fluxgrd(ngrid))  
         ALLOCATE(qsurf(ngrid,nq))  
-        ALLOCATE(q2(ngrid,nlayermx+1)) 
-        ALLOCATE(ztprevious(ngrid,nlayermx))
-        ALLOCATE(cloudfrac(ngrid,nlayermx))
+        ALLOCATE(q2(ngrid,nlayer+1)) 
+        ALLOCATE(ztprevious(ngrid,nlayer))
+        ALLOCATE(cloudfrac(ngrid,nlayer))
         ALLOCATE(totcloudfrac(ngrid))
         ALLOCATE(hice(ngrid))
         ALLOCATE(qsurf_hist(ngrid,nq))
-        ALLOCATE(reffrad(ngrid,nlayermx,naerkind))
-        ALLOCATE(nueffrad(ngrid,nlayermx,naerkind))
+        ALLOCATE(reffrad(ngrid,nlayer,naerkind))
+        ALLOCATE(nueffrad(ngrid,nlayer,naerkind))
         ALLOCATE(ice_initial(ngrid))
         ALLOCATE(ice_min(ngrid)) 
@@ -494,6 +495,6 @@
         ALLOCATE(OSR_nu(ngrid,L_NSPECTV))
         ALLOCATE(sensibFlux(ngrid))
-        ALLOCATE(zdtlw(ngrid,nlayermx))
-        ALLOCATE(zdtsw(ngrid,nlayermx))
+        ALLOCATE(zdtlw(ngrid,nlayer))
+        ALLOCATE(zdtsw(ngrid,nlayer))
         ALLOCATE(tau_col(ngrid))
         ALLOCATE(pctsrf_sic(ngrid))
@@ -541,5 +542,5 @@
 !        read startfi (initial parameters)
 !        ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-         call phyetat0(ngrid,"startfi.nc",0,0,nsoilmx,nq,   &
+         call phyetat0(ngrid,nlayer,"startfi.nc",0,0,nsoilmx,nq,   &
                day_ini,time_phys,tsurf,tsoil,emis,q2,qsurf,   &
                cloudfrac,totcloudfrac,hice,  &
@@ -587,5 +588,5 @@
 
 
-           CALL init_masquv(zmasq)
+           CALL init_masquv(ngrid,zmasq)
 
 
@@ -721,10 +722,10 @@
 !     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       
-      pdu(1:ngrid,1:nlayermx) = 0.0
-      pdv(1:ngrid,1:nlayermx) = 0.0
+      pdu(1:ngrid,1:nlayer) = 0.0
+      pdv(1:ngrid,1:nlayer) = 0.0
       if ( .not.nearco2cond ) then
-         pdt(1:ngrid,1:nlayermx) = 0.0
+         pdt(1:ngrid,1:nlayer) = 0.0
       endif
-      pdq(1:ngrid,1:nlayermx,1:nq) = 0.0
+      pdq(1:ngrid,1:nlayer,1:nq) = 0.0
       pdpsrf(1:ngrid)       = 0.0
       zflubid(1:ngrid)      = 0.0
@@ -773,6 +774,6 @@
 !     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
-      zzlay(1:ngrid,1:nlayermx)=pphi(1:ngrid,1:nlayermx)
-      do l=1,nlayermx         
+      zzlay(1:ngrid,1:nlayer)=pphi(1:ngrid,1:nlayer)
+      do l=1,nlayer         
       zzlay(1:ngrid,l)= zzlay(1:ngrid,l)/glat(1:ngrid)
       enddo
@@ -892,9 +893,9 @@
               endif
 	      if(water) then
-                  muvar(1:ngrid,1:nlayermx)=mugaz/(1.e0+(1.e0/epsi-1.e0)*pq(1:ngrid,1:nlayermx,igcm_h2o_vap)) 
-		  muvar(1:ngrid,nlayermx+1)=mugaz/(1.e0+(1.e0/epsi-1.e0)*pq(1:ngrid,nlayermx,igcm_h2o_vap)) 
+                  muvar(1:ngrid,1:nlayer)=mugaz/(1.e0+(1.e0/epsi-1.e0)*pq(1:ngrid,1:nlayer,igcm_h2o_vap)) 
+		  muvar(1:ngrid,nlayer+1)=mugaz/(1.e0+(1.e0/epsi-1.e0)*pq(1:ngrid,nlayer,igcm_h2o_vap)) 
 		  ! take into account water effect on mean molecular weight
 	      else
-                  muvar(1:ngrid,1:nlayermx+1)=mugaz
+                  muvar(1:ngrid,1:nlayer+1)=mugaz
 	      endif 
       
@@ -950,6 +951,6 @@
                     tau_col(ig)     = ntf*tau_col1(ig)     + tf*tau_col(ig)
                     
-                    zdtlw(ig,1:nlayermx) = ntf*zdtlw1(ig,1:nlayermx) + tf*zdtlw(ig,1:nlayermx)
-                    zdtsw(ig,1:nlayermx) = ntf*zdtsw1(ig,1:nlayermx) + tf*zdtsw(ig,1:nlayermx)
+                    zdtlw(ig,1:nlayer) = ntf*zdtlw1(ig,1:nlayer) + tf*zdtlw(ig,1:nlayer)
+                    zdtsw(ig,1:nlayer) = ntf*zdtsw1(ig,1:nlayer) + tf*zdtsw(ig,1:nlayer)
 
                     OSR_nu(ig,1:L_NSPECTV) = ntf*OSR_nu1(ig,1:L_NSPECTV) + tf*OSR_nu(ig,1:L_NSPECTV)		       
@@ -976,5 +977,5 @@
 
 !             Net atmospheric radiative heating rate (K.s-1)
-              dtrad(1:ngrid,1:nlayermx)=zdtsw(1:ngrid,1:nlayermx)+zdtlw(1:ngrid,1:nlayermx)
+              dtrad(1:ngrid,1:nlayer)=zdtsw(1:ngrid,1:nlayer)+zdtlw(1:ngrid,1:nlayer)
 
            elseif(newtonian)then
@@ -982,5 +983,5 @@
 !          b) Call Newtonian cooling scheme
 !          ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-              call newtrelax(ngrid,mu0,sinlat,zpopsk,pt,pplay,pplev,dtrad,firstcall)
+              call newtrelax(ngrid,nlayer,mu0,sinlat,zpopsk,pt,pplay,pplev,dtrad,firstcall)
 
               zdtsurf(1:ngrid) = +(pt(1:ngrid,1)-tsurf(1:ngrid))/ptimestep
@@ -1001,5 +1002,5 @@
 
 
-              dtrad(1:ngrid,1:nlayermx)=0.0
+              dtrad(1:ngrid,1:nlayer)=0.0
               ! hence no atmospheric radiative heating
 
@@ -1015,5 +1016,5 @@
         zplanck(1:ngrid)=emis(1:ngrid)*sigma*zplanck(1:ngrid)*zplanck(1:ngrid)
         fluxrad(1:ngrid)=fluxrad_sky(1:ngrid)-zplanck(1:ngrid)
-        pdt(1:ngrid,1:nlayermx)=pdt(1:ngrid,1:nlayermx)+dtrad(1:ngrid,1:nlayermx)
+        pdt(1:ngrid,1:nlayer)=pdt(1:ngrid,1:nlayer)+dtrad(1:ngrid,1:nlayer)
 
 !-------------------------
@@ -1048,6 +1049,6 @@
          zflubid(1:ngrid)=fluxrad(1:ngrid)+fluxgrd(1:ngrid)
 
-         zdum1(1:ngrid,1:nlayermx)=0.0
-         zdum2(1:ngrid,1:nlayermx)=0.0
+         zdum1(1:ngrid,1:nlayer)=0.0
+         zdum2(1:ngrid,1:nlayer)=0.0
 
 
@@ -1066,5 +1067,5 @@
 	 else
 	 
-           zdh(1:ngrid,1:nlayermx)=pdt(1:ngrid,1:nlayermx)/zpopsk(1:ngrid,1:nlayermx)
+           zdh(1:ngrid,1:nlayer)=pdt(1:ngrid,1:nlayer)/zpopsk(1:ngrid,1:nlayer)
  
            call vdifc(ngrid,nlayer,nq,rnat,zpopsk,   &
@@ -1077,12 +1078,12 @@
               taux,tauy,lastcall)
 
-           zdtdif(1:ngrid,1:nlayermx)=zdhdif(1:ngrid,1:nlayermx)*zpopsk(1:ngrid,1:nlayermx) ! for diagnostic only
-	   zdqevap(1:ngrid,1:nlayermx)=0.
+           zdtdif(1:ngrid,1:nlayer)=zdhdif(1:ngrid,1:nlayer)*zpopsk(1:ngrid,1:nlayer) ! for diagnostic only
+	   zdqevap(1:ngrid,1:nlayer)=0.
 
          end if !turbdiff
 
-         pdv(1:ngrid,1:nlayermx)=pdv(1:ngrid,1:nlayermx)+zdvdif(1:ngrid,1:nlayermx)
-         pdu(1:ngrid,1:nlayermx)=pdu(1:ngrid,1:nlayermx)+zdudif(1:ngrid,1:nlayermx)
-         pdt(1:ngrid,1:nlayermx)=pdt(1:ngrid,1:nlayermx)+zdtdif(1:ngrid,1:nlayermx)
+         pdv(1:ngrid,1:nlayer)=pdv(1:ngrid,1:nlayer)+zdvdif(1:ngrid,1:nlayer)
+         pdu(1:ngrid,1:nlayer)=pdu(1:ngrid,1:nlayer)+zdudif(1:ngrid,1:nlayer)
+         pdt(1:ngrid,1:nlayer)=pdt(1:ngrid,1:nlayer)+zdtdif(1:ngrid,1:nlayer)
          zdtsurf(1:ngrid)=zdtsurf(1:ngrid)+zdtsdif(1:ngrid)
 
@@ -1094,5 +1095,5 @@
 
          if (tracer) then 
-           pdq(1:ngrid,1:nlayermx,1:nq)=pdq(1:ngrid,1:nlayermx,1:nq)+ zdqdif(1:ngrid,1:nlayermx,1:nq)
+           pdq(1:ngrid,1:nlayer,1:nq)=pdq(1:ngrid,1:nlayer,1:nq)+ zdqdif(1:ngrid,1:nlayer,1:nq)
            dqsurf(1:ngrid,1:nq)=dqsurf(1:ngrid,1:nq) + zdqsdif(1:ngrid,1:nq)
          end if ! of if (tracer)
@@ -1171,8 +1172,8 @@
       if(calladj) then
 
-         zdh(1:ngrid,1:nlayermx) = pdt(1:ngrid,1:nlayermx)/zpopsk(1:ngrid,1:nlayermx)
-         zduadj(1:ngrid,1:nlayermx)=0.0
-         zdvadj(1:ngrid,1:nlayermx)=0.0
-         zdhadj(1:ngrid,1:nlayermx)=0.0
+         zdh(1:ngrid,1:nlayer) = pdt(1:ngrid,1:nlayer)/zpopsk(1:ngrid,1:nlayer)
+         zduadj(1:ngrid,1:nlayer)=0.0
+         zdvadj(1:ngrid,1:nlayer)=0.0
+         zdhadj(1:ngrid,1:nlayer)=0.0
 
 
@@ -1184,11 +1185,11 @@
               zdqadj)
 
-         pdu(1:ngrid,1:nlayermx) = pdu(1:ngrid,1:nlayermx) + zduadj(1:ngrid,1:nlayermx)
-         pdv(1:ngrid,1:nlayermx) = pdv(1:ngrid,1:nlayermx) + zdvadj(1:ngrid,1:nlayermx)
-         pdt(1:ngrid,1:nlayermx)    = pdt(1:ngrid,1:nlayermx) + zdhadj(1:ngrid,1:nlayermx)*zpopsk(1:ngrid,1:nlayermx)
-         zdtadj(1:ngrid,1:nlayermx) = zdhadj(1:ngrid,1:nlayermx)*zpopsk(1:ngrid,1:nlayermx) ! for diagnostic only
+         pdu(1:ngrid,1:nlayer) = pdu(1:ngrid,1:nlayer) + zduadj(1:ngrid,1:nlayer)
+         pdv(1:ngrid,1:nlayer) = pdv(1:ngrid,1:nlayer) + zdvadj(1:ngrid,1:nlayer)
+         pdt(1:ngrid,1:nlayer)    = pdt(1:ngrid,1:nlayer) + zdhadj(1:ngrid,1:nlayer)*zpopsk(1:ngrid,1:nlayer)
+         zdtadj(1:ngrid,1:nlayer) = zdhadj(1:ngrid,1:nlayer)*zpopsk(1:ngrid,1:nlayer) ! for diagnostic only
 
          if(tracer) then 
-            pdq(1:ngrid,1:nlayermx,1:nq) = pdq(1:ngrid,1:nlayermx,1:nq) + zdqadj(1:ngrid,1:nlayermx,1:nq) 
+            pdq(1:ngrid,1:nlayer,1:nq) = pdq(1:ngrid,1:nlayer,1:nq) + zdqadj(1:ngrid,1:nlayer,1:nq) 
          end if
 
@@ -1240,10 +1241,10 @@
               zdqc)
 
-         pdt(1:ngrid,1:nlayermx)=pdt(1:ngrid,1:nlayermx)+zdtc(1:ngrid,1:nlayermx)
-         pdv(1:ngrid,1:nlayermx)=pdv(1:ngrid,1:nlayermx)+zdvc(1:ngrid,1:nlayermx)
-         pdu(1:ngrid,1:nlayermx)=pdu(1:ngrid,1:nlayermx)+zduc(1:ngrid,1:nlayermx)
+         pdt(1:ngrid,1:nlayer)=pdt(1:ngrid,1:nlayer)+zdtc(1:ngrid,1:nlayer)
+         pdv(1:ngrid,1:nlayer)=pdv(1:ngrid,1:nlayer)+zdvc(1:ngrid,1:nlayer)
+         pdu(1:ngrid,1:nlayer)=pdu(1:ngrid,1:nlayer)+zduc(1:ngrid,1:nlayer)
          zdtsurf(1:ngrid) = zdtsurf(1:ngrid) + zdtsurfc(1:ngrid)
 
-         pdq(1:ngrid,1:nlayermx,1:nq)=pdq(1:ngrid,1:nlayermx,1:nq)+ zdqc(1:ngrid,1:nlayermx,1:nq) 
+         pdq(1:ngrid,1:nlayer,1:nq)=pdq(1:ngrid,1:nlayer,1:nq)+ zdqc(1:ngrid,1:nlayer,1:nq) 
          ! Note: we do not add surface co2ice tendency
          ! because qsurf(:,igcm_co2_ice) is updated in condens_co2cloud
@@ -1283,14 +1284,14 @@
 !             ----------------
 
-	       dqmoist(1:ngrid,1:nlayermx,1:nq)=0.
-	       dtmoist(1:ngrid,1:nlayermx)=0.
-
-	       call moistadj(ngrid,nq,pt,pq,pdq,pplev,pplay,dtmoist,dqmoist,ptimestep,rneb_man)
-
-               pdq(1:ngrid,1:nlayermx,igcm_h2o_vap) = pdq(1:ngrid,1:nlayermx,igcm_h2o_vap)   &
-	                  +dqmoist(1:ngrid,1:nlayermx,igcm_h2o_vap)
-               pdq(1:ngrid,1:nlayermx,igcm_h2o_ice) =pdq(1:ngrid,1:nlayermx,igcm_h2o_ice)     &
-                          +dqmoist(1:ngrid,1:nlayermx,igcm_h2o_ice)
-               pdt(1:ngrid,1:nlayermx) = pdt(1:ngrid,1:nlayermx)+dtmoist(1:ngrid,1:nlayermx)
+	       dqmoist(1:ngrid,1:nlayer,1:nq)=0.
+	       dtmoist(1:ngrid,1:nlayer)=0.
+
+	       call moistadj(ngrid,nlayer,nq,pt,pq,pdq,pplev,pplay,dtmoist,dqmoist,ptimestep,rneb_man)
+
+               pdq(1:ngrid,1:nlayer,igcm_h2o_vap) = pdq(1:ngrid,1:nlayer,igcm_h2o_vap)   &
+	                  +dqmoist(1:ngrid,1:nlayer,igcm_h2o_vap)
+               pdq(1:ngrid,1:nlayer,igcm_h2o_ice) =pdq(1:ngrid,1:nlayer,igcm_h2o_ice)     &
+                          +dqmoist(1:ngrid,1:nlayer,igcm_h2o_ice)
+               pdt(1:ngrid,1:nlayer) = pdt(1:ngrid,1:nlayer)+dtmoist(1:ngrid,1:nlayer)
 
                !-------------------------
@@ -1321,9 +1322,9 @@
 !        Large scale condensation/evaporation
 !        --------------------------------
-               call largescale(ngrid,nq,ptimestep,pplev,pplay,pt,pq,pdt,pdq,dtlscale,dqvaplscale,dqcldlscale,rneb_lsc)
-
-               pdt(1:ngrid,1:nlayermx) = pdt(1:ngrid,1:nlayermx)+dtlscale(1:ngrid,1:nlayermx)
-               pdq(1:ngrid,1:nlayermx,igcm_h2o_vap) = pdq(1:ngrid,1:nlayermx,igcm_h2o_vap)+dqvaplscale(1:ngrid,1:nlayermx)
-               pdq(1:ngrid,1:nlayermx,igcm_h2o_ice) = pdq(1:ngrid,1:nlayermx,igcm_h2o_ice)+dqcldlscale(1:ngrid,1:nlayermx)
+               call largescale(ngrid,nlayer,nq,ptimestep,pplev,pplay,pt,pq,pdt,pdq,dtlscale,dqvaplscale,dqcldlscale,rneb_lsc)
+
+               pdt(1:ngrid,1:nlayer) = pdt(1:ngrid,1:nlayer)+dtlscale(1:ngrid,1:nlayer)
+               pdq(1:ngrid,1:nlayer,igcm_h2o_vap) = pdq(1:ngrid,1:nlayer,igcm_h2o_vap)+dqvaplscale(1:ngrid,1:nlayer)
+               pdq(1:ngrid,1:nlayer,igcm_h2o_ice) = pdq(1:ngrid,1:nlayer,igcm_h2o_ice)+dqcldlscale(1:ngrid,1:nlayer)
 
                !-------------------------
@@ -1363,5 +1364,5 @@
             if(waterrain)then
 
-               zdqrain(1:ngrid,1:nlayermx,1:nq) = 0.0
+               zdqrain(1:ngrid,1:nlayer,1:nq) = 0.0
                zdqsrain(1:ngrid)    = 0.0
                zdqssnow(1:ngrid)    = 0.0
@@ -1370,9 +1371,9 @@
                    zdtrain,zdqrain,zdqsrain,zdqssnow,cloudfrac)
 
-               pdq(1:ngrid,1:nlayermx,igcm_h2o_vap) = pdq(1:ngrid,1:nlayermx,igcm_h2o_vap) &
-	             +zdqrain(1:ngrid,1:nlayermx,igcm_h2o_vap)
-               pdq(1:ngrid,1:nlayermx,igcm_h2o_ice) = pdq(1:ngrid,1:nlayermx,igcm_h2o_ice) &
-	             +zdqrain(1:ngrid,1:nlayermx,igcm_h2o_ice)
-               pdt(1:ngrid,1:nlayermx) = pdt(1:ngrid,1:nlayermx)+zdtrain(1:ngrid,1:nlayermx)
+               pdq(1:ngrid,1:nlayer,igcm_h2o_vap) = pdq(1:ngrid,1:nlayer,igcm_h2o_vap) &
+	             +zdqrain(1:ngrid,1:nlayer,igcm_h2o_vap)
+               pdq(1:ngrid,1:nlayer,igcm_h2o_ice) = pdq(1:ngrid,1:nlayer,igcm_h2o_ice) &
+	             +zdqrain(1:ngrid,1:nlayer,igcm_h2o_ice)
+               pdt(1:ngrid,1:nlayer) = pdt(1:ngrid,1:nlayer)+zdtrain(1:ngrid,1:nlayer)
                dqsurf(1:ngrid,igcm_h2o_vap) = dqsurf(1:ngrid,igcm_h2o_vap)+zdqsrain(1:ngrid) ! a bug was here
                dqsurf(1:ngrid,igcm_h2o_ice) = dqsurf(1:ngrid,igcm_h2o_ice)+zdqssnow(1:ngrid)
@@ -1419,5 +1420,5 @@
 !        ------------- 
         if (sedimentation) then 
-           zdqsed(1:ngrid,1:nlayermx,1:nq) = 0.0
+           zdqsed(1:ngrid,1:nlayer,1:nq) = 0.0
            zdqssed(1:ngrid,1:nq)  = 0.0
 
@@ -1455,5 +1456,5 @@
               ! and as in rain.F90, whether it falls as rain or snow depends
               ! only on the surface temperature
-           pdq(1:ngrid,1:nlayermx,1:nq) = pdq(1:ngrid,1:nlayermx,1:nq) + zdqsed(1:ngrid,1:nlayermx,1:nq)
+           pdq(1:ngrid,1:nlayer,1:nq) = pdq(1:ngrid,1:nlayer,1:nq) + zdqsed(1:ngrid,1:nlayer,1:nq)
            dqsurf(1:ngrid,1:nq) = dqsurf(1:ngrid,1:nq) + zdqssed(1:ngrid,1:nq)
 
@@ -1483,12 +1484,12 @@
          if(mass_redistrib) then
 
-            zdmassmr(1:ngrid,1:nlayermx) = mass(1:ngrid,1:nlayermx) * &
-	       (   zdqevap(1:ngrid,1:nlayermx)                          &
-	         + zdqrain(1:ngrid,1:nlayermx,igcm_h2o_vap)             &
-		 + dqmoist(1:ngrid,1:nlayermx,igcm_h2o_vap)             &
-		 + dqvaplscale(1:ngrid,1:nlayermx) )
+            zdmassmr(1:ngrid,1:nlayer) = mass(1:ngrid,1:nlayer) * &
+	       (   zdqevap(1:ngrid,1:nlayer)                          &
+	         + zdqrain(1:ngrid,1:nlayer,igcm_h2o_vap)             &
+		 + dqmoist(1:ngrid,1:nlayer,igcm_h2o_vap)             &
+		 + dqvaplscale(1:ngrid,1:nlayer) )
 
             do ig = 1, ngrid
-	       zdmassmr_col(ig)=SUM(zdmassmr(ig,1:nlayermx))
+	       zdmassmr_col(ig)=SUM(zdmassmr(ig,1:nlayer))
             enddo
             
@@ -1503,13 +1504,13 @@
 	 
 
-            pdq(1:ngrid,1:nlayermx,1:nq) = pdq(1:ngrid,1:nlayermx,1:nq) + zdqmr(1:ngrid,1:nlayermx,1:nq)
+            pdq(1:ngrid,1:nlayer,1:nq) = pdq(1:ngrid,1:nlayer,1:nq) + zdqmr(1:ngrid,1:nlayer,1:nq)
             dqsurf(1:ngrid,1:nq)         = dqsurf(1:ngrid,1:nq) + zdqsurfmr(1:ngrid,1:nq)
-            pdt(1:ngrid,1:nlayermx)        = pdt(1:ngrid,1:nlayermx) + zdtmr(1:ngrid,1:nlayermx)
-            pdu(1:ngrid,1:nlayermx)        = pdu(1:ngrid,1:nlayermx) + zdumr(1:ngrid,1:nlayermx)
-            pdv(1:ngrid,1:nlayermx)        = pdv(1:ngrid,1:nlayermx) + zdvmr(1:ngrid,1:nlayermx)
+            pdt(1:ngrid,1:nlayer)        = pdt(1:ngrid,1:nlayer) + zdtmr(1:ngrid,1:nlayer)
+            pdu(1:ngrid,1:nlayer)        = pdu(1:ngrid,1:nlayer) + zdumr(1:ngrid,1:nlayer)
+            pdv(1:ngrid,1:nlayer)        = pdv(1:ngrid,1:nlayer) + zdvmr(1:ngrid,1:nlayer)
 	    pdpsrf(1:ngrid)                = pdpsrf(1:ngrid) + zdpsrfmr(1:ngrid)
             zdtsurf(1:ngrid)               = zdtsurf(1:ngrid) + zdtsurfmr(1:ngrid)
 	    
-!	    print*,'after mass redistrib, q=',pq(211,1:nlayermx,igcm_h2o_vap)+ptimestep*pdq(211,1:nlayermx,igcm_h2o_vap) 
+!	    print*,'after mass redistrib, q=',pq(211,1:nlayer,igcm_h2o_vap)+ptimestep*pdq(211,1:nlayer,igcm_h2o_vap) 
 	 endif
 
@@ -1672,14 +1673,14 @@
  
       ! temperature, zonal and meridional wind
-      zt(1:ngrid,1:nlayermx) = pt(1:ngrid,1:nlayermx) + pdt(1:ngrid,1:nlayermx)*ptimestep
-      zu(1:ngrid,1:nlayermx) = pu(1:ngrid,1:nlayermx) + pdu(1:ngrid,1:nlayermx)*ptimestep
-      zv(1:ngrid,1:nlayermx) = pv(1:ngrid,1:nlayermx) + pdv(1:ngrid,1:nlayermx)*ptimestep
+      zt(1:ngrid,1:nlayer) = pt(1:ngrid,1:nlayer) + pdt(1:ngrid,1:nlayer)*ptimestep
+      zu(1:ngrid,1:nlayer) = pu(1:ngrid,1:nlayer) + pdu(1:ngrid,1:nlayer)*ptimestep
+      zv(1:ngrid,1:nlayer) = pv(1:ngrid,1:nlayer) + pdv(1:ngrid,1:nlayer)*ptimestep
 
       ! diagnostic
-      zdtdyn(1:ngrid,1:nlayermx)     = pt(1:ngrid,1:nlayermx)-ztprevious(1:ngrid,1:nlayermx)
-      ztprevious(1:ngrid,1:nlayermx) = zt(1:ngrid,1:nlayermx)
+      zdtdyn(1:ngrid,1:nlayer)     = pt(1:ngrid,1:nlayer)-ztprevious(1:ngrid,1:nlayer)
+      ztprevious(1:ngrid,1:nlayer) = zt(1:ngrid,1:nlayer)
 
       if(firstcall)then
-         zdtdyn(1:ngrid,1:nlayermx)=0.0
+         zdtdyn(1:ngrid,1:nlayer)=0.0
       endif
 
@@ -1690,5 +1691,5 @@
 
       ! tracers
-      zq(1:ngrid,1:nlayermx,1:nq) = pq(1:ngrid,1:nlayermx,1:nq) + pdq(1:ngrid,1:nlayermx,1:nq)*ptimestep
+      zq(1:ngrid,1:nlayer,1:nq) = pq(1:ngrid,1:nlayer,1:nq) + pdq(1:ngrid,1:nlayer,1:nq)*ptimestep
 
       ! surface pressure
@@ -1798,5 +1799,5 @@
          do iq=1,nq
            do ig=1,ngrid
-              qcol(ig,iq) = SUM( zq(ig,1:nlayermx,iq) * mass(ig,1:nlayermx))
+              qcol(ig,iq) = SUM( zq(ig,1:nlayer,iq) * mass(ig,1:nlayer))
            enddo
          enddo
@@ -1805,14 +1806,14 @@
          reffcol(1:ngrid,1:naerkind)=0.0
          if(co2cond.and.(iaero_co2.ne.0))then
-            call co2_reffrad(ngrid,nq,zq,reffrad(1,1,iaero_co2))
+            call co2_reffrad(ngrid,nlayer,nq,zq,reffrad(1,1,iaero_co2))
             do ig=1,ngrid
-               reffcol(ig,iaero_co2) = SUM(zq(ig,1:nlayermx,igcm_co2_ice)*reffrad(ig,1:nlayermx,iaero_co2)*mass(ig,1:nlayermx))
+               reffcol(ig,iaero_co2) = SUM(zq(ig,1:nlayer,igcm_co2_ice)*reffrad(ig,1:nlayer,iaero_co2)*mass(ig,1:nlayer))
             enddo
          endif
          if(water.and.(iaero_h2o.ne.0))then
-            call h2o_reffrad(ngrid,zq(1,1,igcm_h2o_ice),zt, &
+            call h2o_reffrad(ngrid,nlayer,zq(1,1,igcm_h2o_ice),zt, &
                              reffrad(1,1,iaero_h2o),nueffrad(1,1,iaero_h2o))
             do ig=1,ngrid
-               reffcol(ig,iaero_h2o) = SUM(zq(ig,1:nlayermx,igcm_h2o_ice)*reffrad(ig,1:nlayermx,iaero_h2o)*mass(ig,1:nlayermx))
+               reffcol(ig,iaero_h2o) = SUM(zq(ig,1:nlayer,igcm_h2o_ice)*reffrad(ig,1:nlayer,iaero_h2o)*mass(ig,1:nlayer))
             enddo
          endif
@@ -1989,5 +1990,5 @@
               end do
             if (water) then
-               vmr=zq(1:ngrid,1:nlayermx,igcm_h2o_vap)*mugaz/mmol(igcm_h2o_vap)
+               vmr=zq(1:ngrid,1:nlayer,igcm_h2o_vap)*mugaz/mmol(igcm_h2o_vap)
                call wstats(ngrid,"vmr_h2ovapor",                           &
                           "H2O vapour volume mixing ratio","mol/mol",       & 
